//
//  AppDelegate.m
//  MIDIComm
//
//  Created by Matthias Krauß on 30.09.13.
//  Copyright (c) 2013 Matthias Krauß. All rights reserved.
//

#import "AppDelegate.h"
#import "MIDICollection.h"

@interface AppDelegate ()

@property (readwrite, strong) MIDICollection* midi;

- (void) noteOff:(NSTimer*)timer;

@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    self.midi = [MIDICollection new];
    self.midi.delegate = self;
}

- (IBAction)playNote:(id)sender {
    [self.midi sendNoteOnChannel:1 note:60 /*C4*/ velocity:127];
    [NSTimer scheduledTimerWithTimeInterval:0.2 target:self selector:@selector(noteOff:) userInfo:nil repeats:NO];
}

- (void) noteOff:(NSTimer*)timer {
    [self.midi sendNoteOnChannel:1 note:60 velocity:0];
}

- (IBAction)sendSysex:(id)sender {
    NSString* __strong text = [self.sysexText stringValue];
    NSData* __strong data = [text dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    NSLog(@"sending sysex %@", text);
    [self.midi sendSysEx:(const uint8_t*)[data bytes] length:[data length]];
}

- (void) gotReply:(NSString*)reply {
    [self.sysexResponseLabel setStringValue:reply];
}

@end
